from fastapi import status
from fastapi.responses import JSONResponse


def success_response(code: int = 200, data: dict = None,
                     http_status: int = status.HTTP_200_OK):
    return JSONResponse(
        status_code=http_status,
        content={
            "code": code,
            "message": "success",
            "data": data
        }
    )


def error_response(
        code: int = 503,
        data: dict = None,
        http_status: int = status.HTTP_503_SERVICE_UNAVAILABLE
):
    return JSONResponse(
        status_code=http_status,
        content={
            "code": code,
            "message": "fail",
            "data": data
        }
    )


if __name__ == '__main__':
    print(error_response())
